package com.jh.memsource.model;

import java.util.Collections;
import java.util.List;

/**
 * Common container for paged collections 
 * 
 * @author Jan
 *
 * @param <T>
 */
public class PagedList<T> {

	private static final PagedList<?> EMPTY = new PagedList<>();
	
	private int pages;
	
	private int pageSize;
	
	private int pageNumber;
	
	private List<T> items;

	public PagedList() {
		super();
		items = Collections.emptyList();
	}

	public PagedList(List<T> items, int pageNumber, int pageSize) {
		super();
		this.items = items;
		this.pageSize = pageSize;
		this.pageNumber = pageNumber;
	}

	public int getPages() {
		return pages;
	}

	public void setPages(int pages) {
		this.pages = pages;
	}

	public int getPageSize() {
		return pageSize;
	}

	public void setPageSize(int pageSize) {
		this.pageSize = pageSize;
	}

	public int getPageNumber() {
		return pageNumber;
	}

	public void setPageNumber(int pageNumber) {
		this.pageNumber = pageNumber;
	}

	public List<T> getItems() {
		return items;
	}

	public void setItems(List<T> items) {
		this.items = items;
	}
	
	@SuppressWarnings("unchecked")
	public static <T> PagedList<T> emptyList() {
		return (PagedList<T>) EMPTY;
	}
	
}
